gtkmm: Gdk::DrawingContext Class Reference

gtkmm 3.22.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gdk::DrawingContext Class Reference

Drawing context for GDK windows. More...

`#include <gdkmm/drawingcontext.h>`

Inheritance diagram for Gdk::DrawingContext:
[legend]

## Public Member Functions
| DrawingContext (DrawingContext&& src) noexcept
DrawingContext& | operator= (DrawingContext&& src) noexcept
| ~DrawingContext () noexcept override
GdkDrawingContext* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkDrawingContext* | gobj () const
| Provides access to the underlying C GObject. More...
GdkDrawingContext* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Window > | get_window ()
| Retrieves the window that created the drawing context. More...
Glib::RefPtr< const Window > | get_window () const
| Retrieves the window that created the drawing context. More...
::Cairo::RefPtr< ::Cairo::Region > | get_clip () const
| Retrieves a copy of the clip region used when creating the context. More...
bool | is_valid () const
| Checks whether the given Gdk::DrawingContext is valid. More...
::Cairo::RefPtr< ::Cairo::Context > | get_cairo_context ()
| Retrieves a Cairo context to be used to draw on the Gdk::Window that created the Gdk::DrawingContext. More...
::Cairo::RefPtr< const ::Cairo::Context > | get_cairo_context () const
| Retrieves a Cairo context to be used to draw on the Gdk::Window that created the Gdk::DrawingContext. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Window > > | property_window () const
| The Gdk::Window that created the drawing context. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< DrawingContext > | get_drawing_context_from_cairo_context (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Retrieves the Gdk::DrawingContext that created the Cairo context cr. More...

## Protected Member Functions
| DrawingContext ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gdk::DrawingContext > | wrap (GdkDrawingContext* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Drawing context for GDK windows.

Gdk::DrawingContext is an object that represents the current drawing state of a Gdk::Window.

It's possible to use a Gdk::DrawingContext to draw on a Gdk::Window via rendering API like Cairo or OpenGL.

A Gdk::DrawingContext can only be created by calling Gdk::Window::begin_draw_frame() and will be valid until a call to Gdk::Window::end_draw_frame().

Since gtkmm 3.22:

## Constructor & Destructor Documentation

## ◆ DrawingContext() [1/2]

Gdk::DrawingContext::DrawingContext | ( | DrawingContext&& | src | ) |
| noexcept

## ◆ ~DrawingContext()

Gdk::DrawingContext::~DrawingContext | ( |  | ) |
| overridenoexcept

## ◆ DrawingContext() [2/2]

Gdk::DrawingContext::DrawingContext | ( |  | ) |
| protected

## Member Function Documentation

## ◆ get_cairo_context() [1/2]

::Cairo::RefPtr< ::Cairo::Context> Gdk::DrawingContext::get_cairo_context | ( |  | ) |

Retrieves a Cairo context to be used to draw on the Gdk::Window that created the Gdk::DrawingContext.

The returned context is guaranteed to be valid as long as the Gdk::DrawingContext is valid, that is between a call to Gdk::Window::begin_draw_frame() and Gdk::Window::end_draw_frame().

Since gtkmm 3.22:

Returns
  A Cairo context to be used to draw the contents of the Gdk::Window. The context is owned by the Gdk::DrawingContext and should not be destroyed.

## ◆ get_cairo_context() [2/2]

::Cairo::RefPtr<const ::Cairo::Context> Gdk::DrawingContext::get_cairo_context | ( |  | ) | const

Retrieves a Cairo context to be used to draw on the Gdk::Window that created the Gdk::DrawingContext.

The returned context is guaranteed to be valid as long as the Gdk::DrawingContext is valid, that is between a call to Gdk::Window::begin_draw_frame() and Gdk::Window::end_draw_frame().

Since gtkmm 3.22:

Returns
  A Cairo context to be used to draw the contents of the Gdk::Window. The context is owned by the Gdk::DrawingContext and should not be destroyed.

## ◆ get_clip()

::Cairo::RefPtr< ::Cairo::Region> Gdk::DrawingContext::get_clip | ( |  | ) | const

Retrieves a copy of the clip region used when creating the context.

Since gtkmm 3.22:

Returns
  A Cairo region.

## ◆ get_drawing_context_from_cairo_context()

static Glib::RefPtr<DrawingContext> Gdk::DrawingContext::get_drawing_context_from_cairo_context | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr | ) |
| static

Retrieves the Gdk::DrawingContext that created the Cairo context cr.

Since gtkmm 3.22:

Parameters

  cr | A Cairo context.

Returns
  A Gdk::DrawingContext, if any is set.

## ◆ get_type()

static GType Gdk::DrawingContext::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_window() [1/2]

Glib::RefPtr<Window> Gdk::DrawingContext::get_window | ( |  | ) |

Retrieves the window that created the drawing context.

Since gtkmm 3.22:

Returns
  A Gdk::Window.

## ◆ get_window() [2/2]

Glib::RefPtr<const Window> Gdk::DrawingContext::get_window | ( |  | ) | const

Retrieves the window that created the drawing context.

Since gtkmm 3.22:

Returns
  A Gdk::Window.

## ◆ gobj() [1/2]

GdkDrawingContext* Gdk::DrawingContext::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GdkDrawingContext* Gdk::DrawingContext::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GdkDrawingContext* Gdk::DrawingContext::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_valid()

bool Gdk::DrawingContext::is_valid | ( |  | ) | const

Checks whether the given Gdk::DrawingContext is valid.

Since gtkmm 3.22:

Returns
  `true` if the context is valid.

## ◆ operator=()

DrawingContext& Gdk::DrawingContext::operator= | ( | DrawingContext&& | src | ) |
| noexcept

## ◆ property_window()

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Window> > Gdk::DrawingContext::property_window | ( |  | ) | const

The Gdk::Window that created the drawing context.

Since gtkmm 3.22:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gdk::DrawingContext > wrap | ( | GdkDrawingContext * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.